(*
This file is part of the dpll(t) engine sammy
Copyright (C) 2004  The University of Iowa
Cesare Tinelli

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*)


exception Invalid_argument of string

module A = Array

type 'a c_array = { mutable start: int;
        array: 'a array 
      }

let length ca = A.length ca.array


let get ca = 
  let l = A.length ca.array in
    fun i -> ca.array.((ca.start + i) mod l)

let set ca = 
  let l = A.length ca.array in
    fun i x -> ca.array.((ca.start + i) mod l) <- x

let make n x = 
  if n == 0 then
    raise (Invalid_argument "C_array.make")
  else
    { start = 0;
      array = A.make n x
    }

let of_list l =
    { start = 0;
      array = A.of_list l
    }

let set_start ca = 
  let l = A.length ca.array in
    fun i -> 
      if 0 <= i && i < l then 
  ca.start <- (ca.start + i) mod l
      else
  raise (Invalid_argument "C_array.set_start")
